Bric::Biz::Asset::Formatting(3)

NAME
Bric::Biz::Asset::Formatting - Template assets

VERSION
$LastChangedRevision$

DATE
$LastChangedDate: 2004-07-07 23:39:24 -0700 (Wed, 07 Jul 2004) $

SYNOPSIS
 # Creation of Objects
 $fa = Bric::Biz::Asset::Formatting->new( $init )
 $fa = Bric::Biz::Asset::Formatting->lookup( { id => $id })
 ($fa_list || @fas) = Bric::Biz::Asset::Formatting->list( $param )
 ($faid_list || @fa_ids) = Bric::Biz::Asset::Formatting->list_ids( $param )

 # get / set the data that is contained with in
 $fa = $fa->set_data()
 $data = $fa->get_data()

 # get the file name that this will be deployed to
 $file_name = $fa->get_file_name()

 # get / set the date that this will activate
 $date = $fa->get_deploy_date()
 $fa = $fa->set_deploy_date($date)

 # get the output channel that this is associated with
 $output_channel_id = $fa->get_output_channel__id()

 # get the asset type that this is associated with
 $element__id = $fa->get_element__id()

 # get the category that this is associated with
 $category_id = $fa->get_category_id()

 # Methods Inheriated from Bric::Biz::Asset

 # Class Methods
 $key_name = Bric::Biz::Asset->key_name()
 %priorities = Bric::Biz::Asset->list_priorities()
 $data = Bric::Biz::Asset->my_meths

 # looking up of objects
 ($asset_list || @assets) = Bric::Biz::Asset->list( $param )

 # General information
 $asset       = $asset->get_id()
 $asset       = $asset->set_name($name)
 $name        = $asset->get_name()
 $asset       = $asset->set_description($description)
 $description = $asset->get_description()
 $priority    = $asset->get_priority()
 $asset       = $asset->set_priority($priority)

 # User information
 $usr_id      = $asset->get_user__id()
 $modifier    = $asset->get_modifier()

 # Version information
 $vers        = $asset->get_version();
 $vers_id     = $asset->get_version_id();
 $current     = $asset->get_current_version();
 $checked_out = $asset->get_checked_out()

 # Expire Data Information
 $asset       = $asset->set_expire_date($date)
 $expire_date = $asset->get_expire_date()

 # Desk stamp information
 ($desk_stamp_list || @desk_stamps) = $asset->get_desk_stamps()
 $desk_stamp                        = $asset->get_current_desk()
 $asset                             = $asset->set_current_desk($desk_stamp)

 # Workflow methods.
 $id    = $asset->get_workflow_id;
 $obj   = $asset->get_workflow_object;
 $asset = $asset->set_workflow_id($id);

 # Access note information
 $asset                 = $asset->add_note($note)
 ($note_list || @notes) = $asset->get_notes()

 # Access active status
 $asset            = $asset->deactivate()
 $asset            = $asset->activate()
 ($asset || undef) = $asset->is_active()

 $asset = $asset->save()

 # returns all the groups this is a member of
 ($grps || @grps) = $asset->get_grp_ids()

DESCRIPTION
This has changed, it will need to be updated in a bit

INTERFACE

  Constructors

$fa = Bric::Biz::Asset::Formatting->new( $initial_state )
    Constructs a new template.

    Supported Keys:

    *   description

    *   data

    *   deploy_date

    *   expire_date

    *   workflow_id

    *   output_channel - Required unless output channel id passed

    *   output_channel__id - Required unless output channel object passed

    *   tplate_type - The type of template it is.

    *   name - The name of the template. Only used if tplate_type is set to UTILITY_TEMPLATE.

    *   element - the at object

    *   element__id - the id of the asset type

    *   category - the category object

    *   category__id - the category id

    *   file_type - the type of the template file - this will be used as the extension for the file_name derived from the element name. Supported file_type values are those returned as the first value in each array reference in the array reference returned by "Bric::Util::Burner->list_file_types".

    Throws:

    *   Missing required output channel parameter.

    *   Missing required parameter 'element' or 'element__id'.

    *   Invalid file_type parameter.

    *   Missing required parameter 'name'

    *   Invalid tplate_type parameter.

    *   Missing required parameter 'category' or 'category_id'.

    *   The template already exists in the output channel.

    Side Effects: NONE.

    Notes: NONE.

$formatting = Bric::Biz::Formatting->lookup( $param )
    Returns an object that matches the parameters

    Suported Keys

    id  A formatting asset ID.

    version
        Pass to request a specific version otherwise the most current will be returned.

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    Inherited from Bric::Biz::Asset.

($fa_list || @fas) = Bric::Biz::Asset::Formatting->list( $criteria )
    This will return a list of blessed objects that match the defined criteria

    Supported Keys:

    *   active - defaults to true

    *   user__id - if defined will return the versions checked out to the user with this id. Otherwise , unless "checked_out" is passed, it will return the most current non-checked out versions.

    *   checked_out - A boolean value indicating whether to return only checked out or not checked out templates.

    *   checked_out - Indicates whether to list templates that are checked out or not. If "0", then only non-checked out templates will be returned. If "1", then only checked-out templates will be returned. If "all", then the checked_out attributed will be ignored (unless the "user__id" parameter is passed).

    *   return_versions - will return all the versions of the given templates

    *   id

    *   workflow_id

    *   output_channel_id

    *   tplate_type

    *   element_id

    *   category_id

    *   name

    *   file_name

    *   deploy_date_start

    *   deploy_date_stop

    *   expire_date_start

    *   expire_date_stop

    *   Order - A property name to order by.

    *   OrderDirection - The direction in which to order the records, either "ASC" for ascending (the default) or "DESC" for descending.

    *   Limit - A maximum number of objects to return. If not specified, all objects that match the query will be returned.

    *   Offset - The number of objects to skip before listing the remaining objcts or the number of objects specified by "Limit".

    *   simple - a single OR search that hits name and filename

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    Inherited from Bric::Biz::Asset.

  Destructors

$template->DESTROY
    Dummy method to prevent wasting time trying to AUTOLOAD DESTROY.

  Public Class Methods

($ids || @ids) = Bric::Biz::Asset::Formatting->list_ids($param)
    Returns an unordered list or array reference of template object IDs that match the criteria defined. The criteria are the same as those for the "list()" method except for "Order" and "OrderDirection", which "list_ids()" ignore.

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    Inherited from Bric::Biz::Asset.

my $key_name = Bric::Biz::Asset::Formatting->key_name()
    Returns the key name of this class.

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    NONE

$meths = Bric::Biz::Asset::Formatting->my_meths
(@meths || $meths_aref) = Bric::Biz::Asset::Formattiong->my_meths(TRUE)
my (@meths || $meths_aref) = Bric::Biz:::Asset::Formatting->my_meths(0, TRUE)
    Returns an anonymous hash of introspection data for this object. If called with a true argument, it will return an ordered list or anonymous array of introspection data. If a second true argument is passed instead of a first, then a list or anonymous array of introspection data will be returned for properties that uniquely identify an object (excluding "id", which is assumed).

    Each hash key is the name of a property or attribute of the object. The value for a hash key is another anonymous hash containing the following keys:

    name
        The name of the property or attribute. Is the same as the hash key when an anonymous hash is returned.

    disp
        The display name of the property or attribute.

    get_meth
        A reference to the method that will retrieve the value of the property or attribute.

    get_args
        An anonymous array of arguments to pass to a call to get_meth in order to retrieve the value of the property or attribute.

    set_meth
        A reference to the method that will set the value of the property or attribute.

    set_args
        An anonymous array of arguments to pass to a call to set_meth in order to set the value of the property or attribute.

    type
        The type of value the property or attribute contains. There are only three types:

        short
        date
        blob
    len If the value is a 'short' value, this hash key contains the length of the field.

    search
        The property is searchable via the list() and list_ids() methods.

    req The property or attribute is required.

    props
        An anonymous hash of properties used to display the property or attribute. Possible keys include:

        type
            The display field type. Possible values are

            text
            textarea
            password
            hidden
            radio
            checkbox
            select
        length
            The Length, in letters, to display a text or password field.

        maxlength
            The maximum length of the property or value - usually defined by the SQL DDL.

    rows
        The number of rows to format in a textarea field.

    cols
        The number of columns to format in a textarea field.

    vals
        An anonymous hash of key/value pairs representing the values and display names to use in a select list.

    Throws: NONE.

    Side Effects: NONE.

    Notes: NONE.

my $tplate_type = Bric::Biz::Asset::Formatting->get_tplate_type_code($str)
    Returns the template type number for a string value as returned by "get_tplate_type_string()".

    Throws: NONE.

    Side Effects: NONE.

    Notes: NONE.

  Public Instance Methods

$template = $template->set_deploy_date($date)
$template = $template->set_cover_date($date)
    Sets the deployment date for this template

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    NONE

$date = $template->get_deploy_date()
$date = $template->get_cover_date()
    Returns the deploy date set upon this template

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    NONE

$status = $template->get_deploy_status()
$template = $template->get_publish_status()
    Returns the deploy status of the formatting asset

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    this will return the deploy date

$template = $template->set_deploy_status()
$template = $template->set_publish_status()
    sets the deploy status for this template

    Throws:

    NONE

    Side Effect:

    NONE

    Notes:

    This is really the deploy date

$uri = $template->get_uri
    Returns the URI for the template. This differs from the file_name in that the latter uses the semantics of your local file system.w

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    NONE

$file_name = $template->get_file_name()
    Returns the file path of this template.

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    NONE

$name = $template->get_output_channel_name;
    Return the name of the output channel.

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    NONE

$name = $template->get_output_channel;
    Return the output channel associated with this Formatting asset.

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    NONE

my $tplate_type_string = $template->get_tplate_type_string
    Returns a the stringified name of the template type attribute.

    Throws: NONE.

    Side Effects: NONE.

    Notes: NONE.

$name = $template->get_element_name;
    Return the name of the element associated with this object.

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    NONE

$key_name = $template->get_element_key_name;
    Return the key name of the element associated with this object.

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    NONE

$at_obj = $template->get_element
    Return the AssetType object for this formatting asset.

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    NONE

$fa = $fa->set_category_id($id)
    Sets the category id for this formatting asset

    Throws:

    *   The template already exists in the output channel.

    Side Effects:

    NONE

    Notes:

    NONE

$fa = $fa->get_cagetory_id
    Get the category ID for this formatting asset.

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    NONE

$fa = $fa->get_category
    Returns the category object that has been associated with this formatting asset.

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    NONE

$fa = $fa->get_cagetory_path
    Returns the path from the category

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    NONE

$fa = $fa->get_cagetory_name
    Get the category name of the category object associated with this formatting asset.

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    NONE

$template = $template->set_data( $data )
    Set the main data for the formatting asset. In future incarnations there might be more data points that surround this, but not for now.

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    NONE

$data = $template->get_data()
    Returns the chunk of text that makes up this template.

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    NONE

$format = $format->checkout($param);
    This will create a flag to add a new record to the instance table

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    NONE

($fa || undef) = $fa->is_current()
    Return whether this is the most current version or not.

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    NONE

$fa = $fa->cancel()
    This cancles a checkout. This will delete the record from the database

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    NONE

$fa = $fa->revert()
    This will take an older version and copy its data to this version

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    NONE

$fa = $fa->save()
    this will update or create a record in the database

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    NONE

  PRIVATE
    ################################################################################

  Private Instance Methods

$oc_obj = $self->_get_output_channel_object()
    Returns the output channel object associated with this formatting object

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    NONE

$at_obj = $self->_get_element_object()
    Returns the asset type object that was associated with this formatting asset.

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    NONE

$cat_obj = $self->_get_category_object()
    Returns the category object that this is associated with

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    NONE

$attr_obj = $self->_get_attribute_object()
    Returns the attribute object that is associated with this formatting object

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    NONE

$self = $self->_insert_formatting();
    Inserts a row into the formatting table that represents a new formatting Asset.

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    NONE

$self = $self->_insert_instance()
    Inserts a row associated with an instance of a formatting asset

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    NONE

$self = $self->_update_formatting()
    Updates the formatting table

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    NONE

$self = $self->_update_instance()
    Updates the row related to the instance of the formatting asset

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    NONE

$self = $self->_delete_formatting()
    Removes the row associated with this formatting asset from the database

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    NONE

$self = $self->_delete_instance()
    Removes the instance specific row from the database

    Throws:

    NONE

    Side Effects:

    NONE

    Notes:

    NONE

my $uri = $self->_build_file_name($file_type, $name, $cat);
    Builds the file name for a template. If $file_type, $name, or $cat are not passed, they'll be fetched (or for $file_type, computed) from $self.

    Throws:

    *   The template already exists in the output channel.

    Side Effects: NONE.

    Notes: NONE.

  Private Functions

my $name = $set_elem->($init)
    Sets the name of the template based on an element association.

    Throws:

    *   Missing required parameter 'element' or 'element__id'.

    Side Effects: NONE.

    Notes: NONE.

my $name = $set_util->($init)
    Sets the name of the template as a utility template, based on the "name" parameter.

    Throws:

    *   Missing required parameter 'name'.

    Side Effects: NONE.

    Notes: NONE.

NOTES
NONE

AUTHOR
michael soderstrom - miraso@pacbell.net

SEE ALSO
Bric, Bric::Biz::Asset